// N88-DiskBASIC t@CovO n88file.exe

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "d88.h"

static unsigned char dir[0x100 * 22];		// Directory (12sector)
static unsigned char fat[0x100];			// FAT (1sector)
static unsigned char buffer[0x100*26*154];	// 256byte x 26sector x 154track
static char dirpath[FILENAME_MAX];			// 쐬fBNg

void usage(int _code)
{
	fprintf(stderr, "Usage: n88file.exe [d88file] [-d][-b][-s[0|1|2]]\n");
	fprintf(stderr, "       -d  : TufBNg쐬Ȃ\n");
	fprintf(stderr, "       -b  : @Bt@Cbsavewb_؂藎Ƃ\n");
	fprintf(stderr, "       -s0 : t@C̃Xy[X폜ďo (default)\n");
	fprintf(stderr, "       -s1 : t@C̃Xy[X̂܂܏o\n");
	fprintf(stderr, "       -s2 : t@C̃Xy[X _ ɒuďo\n");
	fprintf(stderr, "       -p  : gqp̃sIhtȂ\n");
	fprintf(stderr, "       -v  : bsaveTCYBASICƓɍsȂ\n");
	fprintf(stderr, "       -f  : dt@C $ tďo\n");
	exit(_code);
}

bool filecheck(const char *_filename) {
	bool ret = false;
	FILE *fp = NULL;
	fp = fopen(_filename, "rb");
	if (fp) {
		fclose(fp);
		ret = true;
	}
	return ret;
}

int main(int argc, char *argv[])
{
	int mode=1;
	int space=0;
	int bscut=0,bh=0;
	int period=1;
	int fcheck=0;
	int bexact=0;
	int trk,fn;
	int i;
	D88 disk;
	FILE *fp = NULL;

	fprintf(stderr,"N88-Disk BASIC FILE CUTTER version 0.93\n");

	// R}hC
	if (argc<2) usage(1);
	if (argc>2) {
		for (i=2; i<argc; i++) {
			if (!strcmp(argv[i],"-?") || !strcmp(argv[i],"-h") ) usage(1);
			if (!strcmp(argv[i],"-d")) mode=0;
			if (!strcmp(argv[i],"-b")) bscut=1;
			if (!strcmp(argv[i],"-p")) period=0;
			if (!strcmp(argv[i],"-f")) fcheck=1;
			if (!strcmp(argv[i],"-v")) bexact=1;
			if (!strncmp(argv[i],"-s",2)) {
				if (*(argv[i]+2)>='0' && *(argv[i]+2)<='2') {
					space = *(argv[i]+2)-'0';
				}
			}
		}
	}

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W
	int d,media;
	int secnum,trknum,clsnum,dirtrk,dirsec,fatsec,clsmax;
	int start,end,size;

	for (d=0; d<numdisk; d++) {
		memset(dir,0,sizeof(dir));
		memset(fat,0,sizeof(fat));
		memset(buffer,0,sizeof(buffer));
		bool singleside = false;

		disk.SelectDisk(d);
		media = disk.GetDiskType();		// fBXNʂ擾
		switch (media) {
			case disk.TYPE_2D:
				// gbÑ[ho邩ǂ2D/1D𔻒
				if (disk.ReadID(1, buffer, 4)) {
					printf("MEDIA TYPE = 2D\n");
					secnum = 16;	// ZN^/gbN
					trknum = 80;	// gbN/fBXN
					clsnum = 8;		// ZN^/NX^
					dirtrk = 37;	// fBNg̃gbN
					dirsec = 12;	// fBNg̃ZN^
					fatsec = 14;	// FAT̊JnZN^
				}
				else {
					printf("MEDIA TYPE = 1D\n");
					secnum = 16;	// ZN^/gbN
					trknum = 40;	// gbN/fBXN
					clsnum = 8;		// ZN^/NX^
					dirtrk = 18;	// fBNg̃gbN
					dirsec = 12;	// fBNg̃ZN^
					fatsec = 14;	// FAT̊JnZN^
					singleside = true;
				}
				break;

			case disk.TYPE_2DD:
				printf("MEDIA TYPE = 2DD\n");
				secnum = 16;
				trknum = 160;
				clsnum = 16;
				dirtrk = 80;
				dirsec = 12;
				fatsec = 14;
				break;
			case disk.TYPE_2HD:
				printf("MEDIA TYPE = 2HD\n");
				secnum = 26;
				trknum = 154;
				clsnum = 26;
				dirtrk = 70;
				dirsec = 22;
				fatsec = 24;
				break;
		}
		disk.SetRecordRange(1,secnum);	// gbÑZN^ݒ
		clsmax = secnum*trknum/clsnum;	// NX^ől

		if (mode) {
			sprintf(dirpath,"%03d",d);		// fBNg̐
			_mkdir(dirpath);
			_chdir(dirpath);
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}
		else printf("\n[%s]\n",disk.GetDiskName());

		if (!singleside){
			// 2D, 2DD, 2HD
			// fBNgǂݍ
			if (disk.ReadDATA(dirtrk, dirtrk>>1, dirtrk&1, 1, 1, dir, 0x100*dirsec)!=0x100*dirsec) continue;
			// FATǂݍ
			if (disk.ReadDATA(dirtrk, dirtrk>>1, dirtrk&1, fatsec, 1, fat, 0x100)!=0x100) continue;
			// gbNPʂŃfBXNC[WۂƓǂݍ
			for (trk=0; trk<trknum; trk++) {
				disk.ReadDATA(trk, trk>>1, trk&1, 0x01, 0x01, &buffer[0x100*secnum*trk], 0x100*secnum);
			}
		}
		else {
			// 2DƂēǂ1D
			// fBNgǂݍ
			if (disk.ReadDATA(dirtrk*2, dirtrk, 0, 1, 1, dir, 0x100*dirsec)!=0x100*dirsec) continue;
			// FATǂݍ
			if (disk.ReadDATA(dirtrk*2, dirtrk, 0, fatsec, 1, fat, 0x100)!=0x100) continue;
			// gbNPʂŃfBXNC[WۂƓǂݍ
			for (trk=0; trk<trknum; trk++) {
				// 2DƂēǂ1DC[W
				disk.ReadDATA(trk*2, trk, 0, 0x01, 0x01, &buffer[0x100*secnum*trk], 0x100*secnum);
			}
		}

		// t@C̐؂o
		for (fn=0; fn<sizeof(dir)/0x10; fn++) {
			unsigned char *ent = &dir[fn*0x10];		// fBNgGg|C^`

			if (ent[0] == 0x00) continue;	// killꂽt@C̓XLbv
			if (ent[0] == 0xff) break;		// fBNg̍Ō

			char fname[FILENAME_MAX];		// t@C

			int fnp=0;
			for (i=0; i<9; i++) {
				if (i==6 && period) fname[fnp++] = '.';	// gqKvȂt
				char c=ent[i];			// t@CPo
				if (c==' ' && space==0) continue; 	// Xy[X̍폜
				if (c==' ' && space==2) c='_';		// Xy[X̒u
				if (strchr("?*/\\:<>|",c)) c='#';	// DOSŎgpłȂ̒u
				fname[fnp++] = c;		// t@C\
			}
			fname[fnp++] = '\0';		// ̍Ō

			if (fcheck) {
				// dt@C̃`FbN (d͌ $ ₤)
				while (filecheck(fname)) {
					strcat(fname,"$");
				}
			}

			bh=0, size=0;
			fp = fopen(fname, "wb");	// o̓t@CI[v
			if (fp == NULL) continue;
			printf("%-10s",fname);
			if (bscut && (ent[9]&1==1)) {
				bh = 4;
				printf(" *** [HEADER CUT]");
			}

			int cluster = ent[10];			// JnNX^
			if (bscut && (ent[9]&1==1)) {	// @Bt@C -b t̎̓wb_QƂăTCY
				// end͎ۂ̃GhAhX+1
				start = (buffer[cluster*0x100*clsnum+1]<<8) + buffer[cluster*0x100*clsnum];
				end   = (buffer[cluster*0x100*clsnum+3]<<8) + buffer[cluster*0x100*clsnum+2];
				if (start>end) {
					printf(" BSAVE HEADER ERROR!!\n");
					continue;
				}
				size  = end - start + 1 - bexact +4 - bh;
				printf(" ADDR=%04x END=%04x",start,end - bexact);
			}
			if (cluster>=clsmax) {
				printf(" ** NX^j **\n");
				break;
			}
			printf("\n");

			while (fat[cluster] < 0xc0) {
				// bsavet@CTCYNX^TCYɖȂꍇ͔
				if (bscut && (ent[9]&1==1) && (size<clsnum*0x100)) break;
				fwrite(&buffer[cluster*0x100*clsnum+bh], 1, 0x100*clsnum-bh, fp);	// 1NX^
				size = size-(clsnum*0x100-bh);
				bh = 0;
				if (ferror(fp)) {
					fprintf(stderr, "t@C߂܂.\n");
					return 1;
				}
				cluster = fat[cluster];	// FAT`FCH
				if (cluster>=clsmax) {
					printf("** NX^j **\n");
					break;
				}
			}

			// `FC̍Ō
			if (bscut && (ent[9]&1==1) && (size>0)) {	// @Bt@C
				fwrite(&buffer[cluster*0x100*clsnum+bh], 1, size, fp);
			}
			else fwrite(&buffer[cluster*0x100*clsnum+bh], 1, 0x100*(fat[cluster] & 0x1f)-bh, fp);
			if (ferror(fp)) { 
				fprintf(stderr, "t@C߂܂.\n");
				return 1;
			}
			fclose(fp);		// t@CN[Y
			fp = NULL;
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}

